/*
   Copyright (c) 1993 by Barking Spider Software, Inc.  All rights reserved.
                                                                           
   Filename...:  treedem3.h
   
   Version....:  1.0
   
   Language...:  Microsoft C/C++ 7.0
   
   Model......:  Small
   
   Environment:  Microsoft Windows 3.1
                                                                           
   Description:  Header for MDI tree control demo 3
                                                                           
   Notes......:  
                                                                           
   History....:
                                                                              
   Author.....:  Peter J. Kaufman
*/

/* INSTANCE DATA */

#define MAX_BITMAP_ID 6

typedef struct TreeDataTag
{
   HWND    hwndTree;
}
TREE_DATA;

typedef TREE_DATA NEAR *NP_TREE_DATA ;



typedef struct ListDataTag
{
   HWND    hwndTree;
}
LIST_DATA;

typedef LIST_DATA NEAR *NP_LIST_DATA ;



typedef struct TreeDatabaseTag
{
   WORD   wIndexOfThisNode;
   WORD   wBitmapIndex;
   WORD   wNumberOfChildren;
   WORD   wIndexOfChildren;
   LPSTR  lpszNodeText;
}
TREE_DATABASE;

typedef TREE_DATABASE FAR *LP_TREE_DATABASE ;



#define IDR_CLOSED_FOLDER    200
#define IDR_OPEN_FOLDER      210
#define IDR_SHEET            220

#define IDR_API              230
#define IDR_ARG              240
#define IDR_TXT              250
#define IDR_RET              260
#define IDR_DSC              270
#define IDR_COM              280

#define IDR_TREEDEMO_ICON    290

#define LISTCTRL_WND_EXTRA   2
#define WND_EXTRA_LIST_DATA  0

#define TREECTRL_WND_EXTRA   2
#define WND_EXTRA_TREE_DATA  0

#define INIT_MENU_POS        0
#define TREECTRL_MENU_POS    1
#define LISTCTRL_MENU_POS    2

#define IDM_NEW_LISTCTRL     10
#define IDM_NEW_TREECTRL     11
#define IDM_CLOSE            12
#define IDM_EXIT             13

#define IDM_TILE             20
#define IDM_CASCADE          21
#define IDM_ARRANGE          22
#define IDM_CLOSEALL         23

#define IDM_FIRSTCHILD       100


/* PROTOTYPES */
long FAR PASCAL _export FrameWndProc  (HWND, UINT, UINT, LONG) ;
BOOL FAR PASCAL _export CloseEnumProc (HWND, LONG) ;
long FAR PASCAL _export TreeCtrlFrameWndProc  (HWND, UINT, UINT, LONG) ;
long FAR PASCAL _export ListCtrlFrameWndProc  (HWND, UINT, UINT, LONG) ;
BOOL FAR PASCAL _export SysColorChangeEnumProc (HWND, LONG) ;
WORD HandleAddChildrenError( HWND hwnd, WORD wErrCode);
HBITMAP CreateBackgroundMatchedBitmap (DWORD dwrgbBackground,
                                       int nBitmapResouce);
short ChangeBitmapToMatchBackground ( DWORD dwrgbBackground,
                                      HANDLE hBitmap,
                                      int nBitmapResouce);
short ReadInDatabases ( void );

/*--------------------------------- EOF -----------------------------------*/
